//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
//
//
//	deditec_convert_functions.cpp
//	project: delib
//
//
//  (c) DEDITEC GmbH, 2013
//  web: http://www.deditec.de/
//  mail: vertrieb@deditec.de
//
// 
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************

// ------------------------------------
// ------------------------------------
// History
// ------------------------------------
// ------------------------------------
//
// DT	13.11.2013	Start DEDITEC-History



// ------------------------------------
// ------------------------------------
// Functions
// ------------------------------------
// ------------------------------------

//  (ULONG) asc2hex (ULONG) 
//  (ULONG) hex2asc (ULONG) 




#include "../embedded/dt_var_defines.h"

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

unsigned long asc2hex (unsigned long z)
{
    unsigned long ret;

    if(z >= '0' && z <= '9') ret = z - '0';
    else if(z >= 'a' && z <= 'f') ret = z - 'a' + 10;
    else if(z >= 'A' && z <= 'F') ret = z - 'A' + 10;
    else ret = 0;

    return ret;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

unsigned long hex2asc(unsigned long z)
{
    unsigned long ret;

    if((z& 0x0f) >= 10) ret = 'A' + (z & 0x0f) -10;
	else ret = '0' + (z & 0x0f);
	    
    return ret;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

unsigned long convert_ip_text_to_4b(char *ip, unsigned long ip_size, unsigned char *octec, unsigned long octec_size)
{
	unsigned long pos_ip = 0;
	unsigned long pos_octec = 0;
	unsigned long octec_value = 0;
	unsigned long octec_count = 0;
	
	// check if octec buffer size is ok
	if(octec_size < 4)
	{
		return RETURN_ERROR;
	}

	// check if ip buffer is valid
	for(pos_ip = 0; pos_ip < ip_size; pos_ip++)
	{
		// check for termination
		if(ip[pos_ip] == '\0')
		{
			break;
		}

		// check if char is NOT 0-9 or '.'
		if(!(((ip[pos_ip] - 48) >= 0 && (ip[pos_ip] - 48) <= 9) || ip[pos_ip] == '.'))
		{
			return RETURN_ERROR;
		}
		
		// count number of octecs
		if(ip[pos_ip] == '.')
		{
			octec_count++;
		}
	}

	// check if there are 3 '.' (4 octecs)
	if(octec_count != 3)
	{	
		return RETURN_ERROR;
	}


	// fill octec buffer
	for(pos_ip = 0; pos_ip < ip_size; pos_ip++)
	{
		if(ip[pos_ip] == '\0')
		{
			break;
		}

		// start new octec
		if(ip[pos_ip] == '.')
		{
			pos_octec++;
			octec_value = 0;
		}
		else
		{
			octec_value = (octec_value * 10) + (ip[pos_ip] - 48); 

			// check if octec is valid 0-255
			if(octec_value > 255 || octec_value < 0)
			{
				return RETURN_ERROR;
			}

			octec[pos_octec] = (unsigned char)octec_value;
		}
	}

	return RETURN_OK;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

