//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
//
//
//	delib_open_close.cpp
//	project: delib
//
//
//	(c) DEDITEC GmbH, 2009-2020
//	web: http://www.deditec.de/
//	mail: vertrieb@deditec.de
//
//
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************

// ------------------------------------
// DEBUG OUTPUT 
//#define DEBUG_OUTPUT		1				// Ausgabe aktivieren (nur fr diese CPP-Datei)
// ACHTUNG !!!! - DAS IST HIER NICHT realisiert .....DEBUG_OUTPUT wird hier nicht benutzt !
// ------------------------------------

// ------------------------------------
// ------------------------------------
// History
// ------------------------------------
// ------------------------------------
//
// DT	13.11.2013	Start DEDITEC-History



// ------------------------------------
// ------------------------------------
// Functions
// ------------------------------------
// ------------------------------------

// check_module_config
// DapiInternGetBusType
// DapiCheckHandle
// DapiOpenModuleIntern
// DapiOpenModule
// DapiOpenModuleEx
// DapiCloseModule
// DapiGetDELIBVersion
// DapiInternCloseAllSubmodules


#define PROGRAM_NAME_IGNORE			1
#define PROGRAM_NAME_INTERN			"DeLibIntern"

// ------------------------------------
// ------------------------------------
// Includes
// ------------------------------------
// ------------------------------------

#include <stdio.h>
#include <string.h>        // memset()
#include "malloc.h"

#include "proj_config.h"

#ifdef __linux__
	// LINUX ---------------
	// LINUX ---------------
	// LINUX ---------------
	#ifdef USE_FTDI
		#include "../usb-ftdi/ftd2xx.h"
	#endif
	
	#include "library/vc/deditec_tcp_io.h"
	#include "library/delib/delib.h"
	#include "library/delib/delib_intern.h"
	#include "library/delib/delib_extended_functions.h"	
	#include "library/communication/dt_communication_paramams.h"
	#include "library/embedded/deditec_debug_comfort.h"

	#include "delib_hdlmgr.h"
	#include "delib_set_get_error.h"
	#include "delib_io_ftdi.h"
	#include "delib_io_tcp.h"
#else
	// WINDOWS ---------------
	// WINDOWS ---------------
	// WINDOWS ---------------
	#include <windows.h>
	#include "delib_io_seriellCOM.h"
	#include "delib_io_ftdi.h"
	#include "delib_io_tcp.h"

	extern DAPI_HANDLE*  DAPI_FUNCTION_PRE  HandleMGR_get_handle_pointer(ULONG nr);
	extern unsigned long DapiInternHandlePointerCreate(unsigned long nr, ULONGLONG handleXXL);
	extern void  DAPI_FUNCTION_PRE  HandleMGR_show_handle_buffer();

#endif

// ------------------------------------
// ------------------------------------
// DELIB-DEBUG
// ------------------------------------
// ------------------------------------
//
// Function															Windows (DEBUGVIEW)			Linux
// -------------------------										----------------------		-------------------------
// DapiSetError(debug_msg)											immer						immer
// debug_error(debug_msg)											immer						immer
// debug_info(debug_msg)											immer						nur bei DEBUG_OUTPUT
// debug_print(debug_msg)											nur bei DEBUG_OUTPUT		nur bei DEBUG_OUTPUT

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

ULONG check_module_config(unsigned long handle32)
{
	DAPI_MODULE_PARAMS *DapiModuleParams;
	char debug_msg[200];

	DAPI_HANDLE *DapiHandle;
	ULONGLONG handle_ull;

	if(DapiInternHandlePointerGet(handle32, &handle_ull) == RETURN_OK)
	{
		DapiHandle = (DAPI_HANDLE*) DAPI_PTR_SIZE handle_ull;
	}
	else
	{
		return DAPI_ERR_GEN_ILLEGAL_HANDLE;
	}

	DapiModuleParams = (DAPI_MODULE_PARAMS*) DAPI_PTR_SIZE DapiHandle->addr_dapi_module_params;

	// Sonst gibt es beim set_error rger...deswegen muss der 
	sprintf(debug_msg, "check_module_config (handle32=0x%lx)", handle32);
	DapiSetErrorCallerParamsSet(handle32, debug_msg, sizeof(debug_msg));

	// ----------------------------------------------------
	// check module config
	
	sprintf(debug_msg,"check_module_config - wird nun durchgefhrt.................................");
	debug_info(debug_msg);

	// hw-interface1 / sw_feature1 / tcp_feature1
	DapiModuleParams->sw_feature1 = 		DapiReadLongXXX(handle32, 0xff30);	if(DapiGetLastError() != 0) return RETURN_ERROR;
	DapiModuleParams->hw_interface1 = 		DapiReadLongXXX(handle32, 0xff34);	if(DapiGetLastError() != 0) return RETURN_ERROR;
	DapiModuleParams->tcp_feature1 = 		DapiReadLongXXX(handle32, 0xffc0);	DapiClearLastError();/////OHNE ERROR
	// count of channel
	DapiModuleParams->anz_do = 				DapiReadWordXXX(handle32, 0xff00);	if(DapiGetLastError() != 0) return RETURN_ERROR;
	DapiModuleParams->anz_di = 				DapiReadWordXXX(handle32, 0xff02);	if(DapiGetLastError() != 0) return RETURN_ERROR;
	DapiModuleParams->anz_di_ff = 			DapiReadWordXXX(handle32, 0xff0c);	if(DapiGetLastError() != 0) return RETURN_ERROR;
	DapiModuleParams->anz_di_counter = 		DapiReadWordXXX(handle32, 0xff0e);	if(DapiGetLastError() != 0) return RETURN_ERROR;
	DapiModuleParams->anz_dx = 				DapiReadWordXXX(handle32, 0xff04);	if(DapiGetLastError() != 0) return RETURN_ERROR;
	DapiModuleParams->anz_ao = 				DapiReadWordXXX(handle32, 0xff06);	if(DapiGetLastError() != 0) return RETURN_ERROR;
	DapiModuleParams->anz_ai = 				DapiReadWordXXX(handle32, 0xff08);	if(DapiGetLastError() != 0) return RETURN_ERROR;
	DapiModuleParams->anz_stepper = 		DapiReadWordXXX(handle32, 0xff0a);	if(DapiGetLastError() != 0) return RETURN_ERROR;
	DapiModuleParams->anz_temp = 			DapiReadWordXXX(handle32, 0xff10);	if(DapiGetLastError() != 0) return RETURN_ERROR;
	DapiModuleParams->anz_counterin48 = 	DapiReadWordXXX(handle32, 0xff12);	if(DapiGetLastError() != 0) return RETURN_ERROR;
	DapiModuleParams->anz_counterout32 = 	DapiReadWordXXX(handle32, 0xff14);	if(DapiGetLastError() != 0) return RETURN_ERROR;
	DapiModuleParams->anz_output_pwm = 		DapiReadWordXXX(handle32, 0xff16);	if(DapiGetLastError() != 0) return RETURN_ERROR;
	
	// module fw
	DapiModuleParams->fw_version[0] = 		(UCHAR) DapiReadByteXXX(handle32, 0xfff4);	if(DapiGetLastError() != 0) return RETURN_ERROR;
	DapiModuleParams->fw_version[1] = 		(UCHAR) DapiReadByteXXX(handle32, 0xfff5);	if(DapiGetLastError() != 0) return RETURN_ERROR;
	DapiModuleParams->fw_version[2] = 		(UCHAR) DapiReadByteXXX(handle32, 0xfff6);	if(DapiGetLastError() != 0) return RETURN_ERROR;
	DapiModuleParams->fw_version[3] = 		(UCHAR) DapiReadByteXXX(handle32, 0xfff7);	if(DapiGetLastError() != 0) return RETURN_ERROR;
	
	DapiModuleParams->sw_class = 			DapiReadLongXXX(handle32, 0xfff0);	if(DapiGetLastError() != 0) return RETURN_ERROR;
	DapiModuleParams->hw_group = 			DapiReadLongXXX(handle32, 0xffec);	if(DapiGetLastError() != 0) return RETURN_ERROR;

	DapiModuleParams->moduleID = 			DapiHandle->moduleID;

	DapiHandle->ftdi_use_protocol_new = TRUE;

	// DEBUG
	debug_set_function_name("check_module_config");																														debug_info(debug_msg);
	debug_info("-----");

	if ((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_CFG_USB2) != 0)
	{
		DapiHandle->ftdi_use_protocol_new = TRUE;
		debug_info("DapiHandle->ftdi_use_protocol_new = TRUE");
	}
	else
	{
		DapiHandle->ftdi_use_protocol_new = FALSE;
		debug_info("DapiHandle->ftdi_use_protocol_new = FALSE");
	}

	if (DapiModuleParams->anz_di != 0) 				{ sprintf(debug_msg,"DapiModuleParams->anz_di         = %ld", (unsigned long) DapiModuleParams->anz_di); 							debug_info(debug_msg); }
	if (DapiModuleParams->anz_di_counter != 0)		{ sprintf(debug_msg,"DapiModuleParams->anz_di_counter = %ld", (unsigned long) DapiModuleParams->anz_di_counter); 					debug_info(debug_msg); }
	if (DapiModuleParams->anz_di_ff != 0)			{ sprintf(debug_msg,"DapiModuleParams->anz_di_ff      = %ld", (unsigned long) DapiModuleParams->anz_di_ff); 						debug_info(debug_msg); }
	if (DapiModuleParams->anz_do != 0)				{ sprintf(debug_msg,"DapiModuleParams->anz_do         = %ld", (unsigned long) DapiModuleParams->anz_do); 							debug_info(debug_msg); }
	if (DapiModuleParams->anz_dx != 0)				{ sprintf(debug_msg,"DapiModuleParams->anz_dx         = %ld", (unsigned long) DapiModuleParams->anz_dx); 							debug_info(debug_msg); }
	if (DapiModuleParams->anz_ai != 0)				{ sprintf(debug_msg,"DapiModuleParams->anz_ai         = %ld", (unsigned long) DapiModuleParams->anz_ai); 							debug_info(debug_msg); }
	if (DapiModuleParams->anz_ao != 0)				{ sprintf(debug_msg,"DapiModuleParams->anz_ao         = %ld", (unsigned long) DapiModuleParams->anz_ao); 							debug_info(debug_msg); }
	if (DapiModuleParams->anz_stepper != 0)			{ sprintf(debug_msg,"DapiModuleParams->anz_stepper    = %ld", (unsigned long) DapiModuleParams->anz_stepper); 						debug_info(debug_msg); }
	if (DapiModuleParams->anz_temp != 0)			{ sprintf(debug_msg,"DapiModuleParams->anz_temp       = %ld", (unsigned long) DapiModuleParams->anz_temp); 							debug_info(debug_msg); }
	if (DapiModuleParams->anz_counterin48 != 0)		{ sprintf(debug_msg,"DapiModuleParams->anz_counterin48= %ld", (unsigned long) DapiModuleParams->anz_counterin48); 					debug_info(debug_msg); }
	if (DapiModuleParams->anz_counterout32 != 0)	{ sprintf(debug_msg,"DapiModuleParams->anz_counterou32= %ld", (unsigned long) DapiModuleParams->anz_counterout32); 					debug_info(debug_msg); }
	if (DapiModuleParams->anz_output_pwm != 0)		{ sprintf(debug_msg,"DapiModuleParams->anz_output_pwm = %ld", (unsigned long) DapiModuleParams->anz_output_pwm); 					debug_info(debug_msg); }
	debug_info("-----");
	sprintf(debug_msg, "DapiModuleParams->fw_version = %c%c.%c%c", DapiModuleParams->fw_version[0], DapiModuleParams->fw_version[1], DapiModuleParams->fw_version[2], DapiModuleParams->fw_version[3]);	debug_info(debug_msg);
	debug_info("-----");
	sprintf(debug_msg,"DapiModuleParams->sw_feature1 = 0x%lx", (unsigned long) DapiModuleParams->sw_feature1);																			debug_info(debug_msg);
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_SUPPORTED_BY_FIRMWARE) != 0)		{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_SUPPORTED_BY_FIRMWARE");		debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_SOFTWARE_FIFO) != 0)				{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_SOFTWARE_FIFO");				debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_DO_CMD_SET_CLR_BIT_32) != 0)	{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_DO_CMD_SET_CLR_BIT_32");	debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_EEPROM_RN23) != 0)					{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_EEPROM_RN23");					debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_DX_1_MODE) != 0)					{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_DX_1_MODE");					debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_AUTO_OUTPUTS_OFF_TIMEOUT) != 0)	{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_AUTO_OUTPUTS_OFF_TIMEOUT");	debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_SUPP_INDIVIDUAL_CH_NAMES) != 0)	{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_SUPP_INDIVIDUAL_CH_NAMES");	debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_WATCHDOG) != 0)				{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_WATCHDOG");				debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_DI) != 0)						{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_DI");						debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_DI_CNT) != 0)					{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_DI_CNT");					debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_DI_CNT_LATCH) != 0)			{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_DI_CNT_LATCH");			debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_DI_FF) != 0)					{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_DI_FF");					debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_DO) != 0)						{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_DO");						debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_DO_WITH_TIMER) != 0)			{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_DO_WITH_TIMER");			debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_PWM_OUT) != 0)					{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_PWM_OUT");					debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_DX) != 0)						{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_DX");						debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_DA) != 0)						{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_DA");						debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_AD) != 0)						{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_AD");						debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_CNT_OUT32) != 0)				{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_CNT_OUT32");				debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_CNT_IN48) != 0)				{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_CNT_IN48");				debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_TEMP) != 0)					{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_TEMP");					debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_STEPPER) != 0)					{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_STEPPER");					debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_SUPP_SYSTEM_INFO) != 0)			{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_SUPP_SYSTEM_INFO");			debug_info(debug_msg); }
	debug_info("-----");
	sprintf(debug_msg,"DapiModuleParams->hw_interface1 = 0x%lx", (unsigned long) DapiModuleParams->hw_interface1);														debug_info(debug_msg);
	if ((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_SUPPORTED_BY_FIRMWARE) != 0)	{ sprintf(debug_msg,"DAPI_HW_INTERFACE_BIT_SUPPORTED_BY_FIRMWARE");		debug_info(debug_msg); }
	if ((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_CFG_ETH) != 0)					{ sprintf(debug_msg,"DAPI_HW_INTERFACE_BIT_CFG_ETH");					debug_info(debug_msg); }
	if ((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_CFG_CAN) != 0)					{ sprintf(debug_msg,"DAPI_HW_INTERFACE_BIT_CFG_CAN");					debug_info(debug_msg); }
	if ((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_CFG_RS232) != 0)				{ sprintf(debug_msg,"DAPI_HW_INTERFACE_BIT_CFG_RS232");					debug_info(debug_msg); }
	if ((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_CFG_RS232_RS485) != 0)			{ sprintf(debug_msg,"DAPI_HW_INTERFACE_BIT_CFG_RS232_RS485");			debug_info(debug_msg); }
	if ((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_CFG_USB1) != 0)				{ sprintf(debug_msg,"DAPI_HW_INTERFACE_BIT_CFG_USB1");					debug_info(debug_msg); }
	if ((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_CFG_USB2) != 0)				{ sprintf(debug_msg,"DAPI_HW_INTERFACE_BIT_CFG_USB2");					debug_info(debug_msg); }
	if ((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_CFG_CANOPEN) != 0)				{ sprintf(debug_msg,"DAPI_HW_INTERFACE_BIT_CFG_CANOPEN");				debug_info(debug_msg); }
	debug_info("-----");
	sprintf(debug_msg,"DapiModuleParams->tcp_feature1 = 0x%lx", (unsigned long) DapiModuleParams->tcp_feature1);														debug_info(debug_msg);
	if ((DapiModuleParams->tcp_feature1 & DAPI_TCP_FEATURE_BIT_SUPPORTED_BY_FIRMWARE) != 0)		{ sprintf(debug_msg,"DAPI_TCP_FEATURE_BIT_SUPPORTED_BY_FIRMWARE");		debug_info(debug_msg); }
	if ((DapiModuleParams->tcp_feature1 & DAPI_TCP_FEATURE_BIT_SUPP_RTC) != 0)					{ sprintf(debug_msg,"DAPI_TCP_FEATURE_BIT_SUPP_RTC");					debug_info(debug_msg); }
	if ((DapiModuleParams->tcp_feature1 & DAPI_TCP_FEATURE_BIT_SUPP_SYSTEM_INFO) != 0)			{ sprintf(debug_msg,"DAPI_TCP_FEATURE_BIT_SUPP_SYSTEM_INFO");			debug_info(debug_msg); }
	debug_info("-----");
	sprintf(debug_msg,"sw_feature_type = 0x%lx", (unsigned long) DapiModuleParams->sw_class);																			debug_info(debug_msg);
	if ((DapiModuleParams->sw_class & DAPI_SW_CLASS_TYPE_OF_MODULE_IDENTIFICATION) != 0)		{ sprintf(debug_msg,"DAPI_SW_CLASS_TYPE_OF_MODULE_IDENTIFICATION");		debug_info(debug_msg); }
	if ((DapiModuleParams->sw_class & DAPI_SW_CLASS_DI_DO_DX_CHANNELS) != 0)					{ sprintf(debug_msg,"DAPI_SW_CLASS_DI_DO_DX_CHANNELS");					debug_info(debug_msg); }
	if ((DapiModuleParams->sw_class & DAPI_SW_CLASS_AD_DA_CHANNELS) != 0)						{ sprintf(debug_msg,"DAPI_SW_CLASS_AD_DA_CHANNELS");					debug_info(debug_msg); }
	debug_info("-----");
	sprintf(debug_msg,"hw_feature_type = 0x%lx", (unsigned long) DapiModuleParams->hw_group);																			debug_info(debug_msg);
	if ((DapiModuleParams->hw_group & DAPI_HW_GROUP_RO) != 0)									{ sprintf(debug_msg,"DAPI_HW_GROUP_RO");								debug_info(debug_msg); }
	if ((DapiModuleParams->hw_group & DAPI_HW_GROUP_LOGICANALYZER) != 0)						{ sprintf(debug_msg,"DAPI_HW_GROUP_LOGICANALYZER");						debug_info(debug_msg); }
	if ((DapiModuleParams->hw_group & DAPI_HW_GROUP_DI_DO_AD_DA) != 0)							{ sprintf(debug_msg,"DAPI_HW_GROUP_DI_DO_AD_DA");						debug_info(debug_msg); }
	if ((DapiModuleParams->hw_group & DAPI_HW_GROUP_USB) != 0)									{ sprintf(debug_msg,"DAPI_HW_GROUP_USB");								debug_info(debug_msg); }
	if ((DapiModuleParams->hw_group & DAPI_HW_GROUP_BS) != 0)									{ sprintf(debug_msg,"DAPI_HW_GROUP_BS");								debug_info(debug_msg); }
	if ((DapiModuleParams->hw_group & DAPI_HW_GROUP_NET) != 0)									{ sprintf(debug_msg,"DAPI_HW_GROUP_NET");								debug_info(debug_msg); }
	debug_info("-----check_module_config END");
	// -----
	return RETURN_OK;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

ULONG DapiInternGetBusType(ULONG moduleID)
{
	ULONG ret;
	char debug_msg[200];

	switch(moduleID)
	{
		// ------------------------------------
		case USB_Interface8:
		case USB_CAN_STICK:
		case USB_LOGI_500:
		case USB_BITP_200:
		case BS_USB_8:				//USB_OPTOIN_8_RELAIS_8:
		case BS_USB_16:				//USB_OPTOIN_16_RELAIS_16:
		case BS_USB_32:				//USB_OPTOIN_32_RELAIS_32:
		case BS_CAN:
		case USB_CANOPEN_STICK:
			ret = bus_FTDI_DUAL;
			break;
		// ------------------------------------
		case RO_USB1:
		case NET_USB1:
			ret = bus_SeriellFTDI;
			break;
		// ------------------------------------
		case RO_SER:
		case NET_SER:
		case BS_SER:
		case RO_CAN:
			ret = bus_SeriellCOM;
			break;
		// ------------------------------------
		case RO_ETH:
		case RO_ETH_LC:
		case BS_ETH:
		case ETH_RELAIS_8:
		case ETH_O4_R4_ADDA:
		case ETH_TTL_64:
		case ETH_CUST_0:
		case ETHERNET_MODULE:
		case NET_ETH:
		case NET_ETH_LC:
			ret = bus_ETH;
			break;
		// ------------------------------------
		case USB_WATCHDOG:
		case USB_MINI_STICK:
		case USB_OPTOIN_8:
		case USB_LOGI_18:
		case USB_SPI_MON:
		case USB_SER_DEBUG:
			ret = bus_FTDI_SINGLE_SER;
			break;
		// ------------------------------------
		case USB_TTL_64:
		case RO_USB2:
		case RO_CAN2:
		case NET_USB2:
			ret = bus_FTDI_SINGLE_PAR;
			break;
		// ------------------------------------	
		#ifdef __linux__
			case RO_ETH_INTERN:
				ret = bus_ETH_INTERN;
				break;
		#endif
		// ------------------------------------
		default:	
			ret = 0;
			sprintf(debug_msg, "DapiInternGetBusType -> Illegal moduleID (ID=0x%lx)", (unsigned long) moduleID);
			DapiSetError(DAPI_ERR_GEN_ERROR_WITH_TEXT, 0, debug_msg, __FILE__, __LINE__);		
			break;
		// ------------------------------------
	}

	return ret;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

ULONG DapiInternGetInterfaceType(ULONG moduleID)
{
	ULONG ret;
	char debug_msg[200];

	switch(moduleID)
	{
		// ------------------------------------
		case USB_Interface8:
		case USB_CAN_STICK:
		case USB_LOGI_500:
		case USB_SER_DEBUG:
		case USB_BITP_200:
		case USB_OPTOIN_8_RELAIS_8:
		case USB_OPTOIN_16_RELAIS_16:
		case USB_OPTOIN_32_RELAIS_32:
		case RO_USB1:
		case NET_USB1:
		case USB_WATCHDOG:
		case USB_MINI_STICK:
		case USB_OPTOIN_8:
		case USB_LOGI_18:
		case USB_SPI_MON:
		case USB_TTL_64:
		case RO_USB2:
		case RO_CAN2:
		case NET_USB2:
		case USB_CANOPEN_STICK:
			ret = DAPI_INTERFACE_USB;
			break;
		// ------------------------------------
		case BS_CAN:
		case RO_CAN:
			ret = DAPI_INTERFACE_CAN;
			break;
		// ------------------------------------
		case RO_SER:
		case NET_SER:
		case BS_SER:
			ret = DAPI_INTERFACE_SER;
			break;
		// ------------------------------------
		case RO_ETH:
		case RO_ETH_LC:
		case BS_ETH:
		case ETH_RELAIS_8:
		case ETH_O4_R4_ADDA:
		case ETH_TTL_64:
		case ETH_CUST_0:
		case ETHERNET_MODULE:
		case NET_ETH:
		case NET_ETH_LC:
			ret = DAPI_INTERFACE_ETH;
			break;
		// ------------------------------------
		default:
			ret = DAPI_INTERFACE_UNDEFINED;
			sprintf(debug_msg, "DapiInternGetInterfaceType -> Illegal moduleID (ID=0x%lx)", (unsigned long) moduleID);
			DapiSetError(DAPI_ERR_GEN_ERROR_WITH_TEXT, 0, debug_msg, __FILE__, __LINE__);		
			break;
		// ------------------------------------
	}

	return ret;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

void DapiInternGetModuleName(ULONG moduleID, char* ModName, unsigned long ModNameSize)
{
	char Name[200];
	unsigned long i;
	
	switch(moduleID)
	{
		case USB_Interface8:				sprintf(Name, "USB-TTL-IN8-OUT8");	break;
		case USB_CAN_STICK:					sprintf(Name, "USB-CAN-Stick");		break;
		case USB_LOGI_500:					sprintf(Name, "USB-LOGI-500");		break;
		case USB_SER_DEBUG:					sprintf(Name, "USB-SER-DEBUG");		break;
		case USB_BITP_200:					sprintf(Name, "USB-BITP-200");		break;
		case USB_OPTOIN_8_RELAIS_8:			sprintf(Name, "BS-USB-8");			break;
		case USB_OPTOIN_16_RELAIS_16:		sprintf(Name, "BS-USB-16");			break;
		case USB_OPTOIN_32_RELAIS_32:		sprintf(Name, "BS-USB-32");			break;
		case BS_CAN:						sprintf(Name, "BS-CAN");			break;
		case RO_USB1:						sprintf(Name, "RO-USB1");			break;
		case RO_SER:						sprintf(Name, "RO-SER");			break;
		case BS_SER:						sprintf(Name, "BS-SER");			break;
		case RO_CAN:						sprintf(Name, "RO-CAN");			break;
		case RO_ETH:						sprintf(Name, "RO-ETH");			break;
		case RO_ETH_LC:						sprintf(Name, "RO-ETH/LC");			break;
		case RO_ETH_INTERN:					sprintf(Name, "RO-ETH-INTERN");		break;
		case BS_ETH:						sprintf(Name, "BS-ETH");			break;
		case USB_WATCHDOG:					sprintf(Name, "USB-Watchdog");		break;
		case USB_MINI_STICK:				sprintf(Name, "USB-Mini-Stick");	break;
		case USB_RELAIS_8:					sprintf(Name, "USB-OPT/REL-8");		break;
		case ETH_RELAIS_8:					sprintf(Name, "ETH-OPT/REL-8");		break;
		case ETH_O4_R4_ADDA:				sprintf(Name, "ETH-O4-R4-ADDA");	break;
		case ETH_TTL_64:					sprintf(Name, "ETH-TTL-64");		break;
		case ETH_CUST_0:					sprintf(Name, "ETH-CUST-0");		break;
		case ETHERNET_MODULE:				sprintf(Name, "ETHERNET-MODULE");	break;
		case USB_LOGI_18:					sprintf(Name, "USB-Logi-18");		break;
		case USB_SPI_MON:					sprintf(Name, "USB-SPI-MON");		break;
		case USB_TTL_64:					sprintf(Name, "USB-TTL-32/64");		break;
		case RO_USB2:						sprintf(Name, "RO-USB2");			break;
		case RO_CAN2:						sprintf(Name, "RO-CAN2");			break;
		case NET_USB1:						sprintf(Name, "NET-USB1");			break;
		case NET_USB2:						sprintf(Name, "NET-USB2");			break;
		case NET_SER:						sprintf(Name, "NET-SER");			break;
		case NET_ETH:						sprintf(Name, "NET-ETH");			break;
		case NET_ETH_LC:					sprintf(Name, "NET-ETH_LC");		break;
		case USB_CANOPEN_STICK:				sprintf(Name, "USB-CANOPEN-STICK");break;
		default:							sprintf(Name, "UNKNOWN");			break;
	}
	i=0;
	do
	{
		if(i<ModNameSize) ModName[i] = Name[i];
		++i;
	} while(i <= strlen_n(Name, sizeof(Name)));
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

#ifndef __linux__
	// WINDOWS ---------------
	// WINDOWS ---------------
	// WINDOWS ---------------
void DapiInternGetModuleConfigText(ULONG moduleID, ULONG moduleNr, char* ModConfigText, unsigned long ModConfigTextSize)
{
	char text[200];
	unsigned long i;
		
	char moduleName[200];
	unsigned char ip_addr[40];
	char reg_key_name[60];
	char reg_key_param[70];
	ULONG reg_key_value_port;
	ULONG reg_key_value_enabled;
	ULONG reg_key_value_timeout;
	ULONG err;

	DapiInternGetRegistryKeyName(moduleID, (char*) reg_key_name, sizeof(reg_key_name));

	DapiInternGetModuleName(moduleID, moduleName, sizeof(moduleName));


	switch(DapiInternGetBusType(moduleID))
	{
		// ------------------------------------------------
		case bus_FTDI_SINGLE_SER:
		case bus_FTDI_SINGLE_PAR:
		case bus_FTDI_DUAL:
		case bus_SeriellFTDI:

			sprintf(text, "Module-Configuration %s (%ld)\n\nInterface: USB", moduleName, (unsigned long) moduleNr);

			break;

		// ------------------------------------------------
		case bus_SeriellCOM:

			// Registry read Server enabled
			sprintf(reg_key_param, "Enabled%ld", (unsigned long) moduleNr);
			err = DapiInternCommand(DAPI_INTERN_CMD_GET_REGISTRY_DWORD, reg_key_name, reg_key_param, 0, 0, &reg_key_value_enabled);

			// Registry read Server Port-No
			sprintf(reg_key_param, "Port%ld",(unsigned long)  moduleNr);
			err = DapiInternCommand(DAPI_INTERN_CMD_GET_REGISTRY_DWORD, reg_key_name, reg_key_param, 0, 0, &reg_key_value_port);

			sprintf(text, "Module-Configuration %s (%ld)\n\nInterface: Seriell\nPort: COM%ld", moduleName, (unsigned long) moduleNr, (unsigned long) reg_key_value_port);

			break;

		// ------------------------------------------------
		case bus_ETH:

			// Registry read Server enabled
			sprintf(reg_key_param, "Enabled%ld", (unsigned long) moduleNr);
			err = DapiInternCommand(DAPI_INTERN_CMD_GET_REGISTRY_DWORD, reg_key_name, reg_key_param, 0, 0, &reg_key_value_enabled);

			// Registry read Server Port-No
			sprintf(reg_key_param, "Port%ld", (unsigned long) moduleNr);
			err = DapiInternCommand(DAPI_INTERN_CMD_GET_REGISTRY_DWORD, reg_key_name, reg_key_param, 0, 0, &reg_key_value_port);

			// Registry read Server Timeout
			sprintf(reg_key_param, "Timeout%ld", (unsigned long) moduleNr);
			err = DapiInternCommand(DAPI_INTERN_CMD_GET_REGISTRY_DWORD, reg_key_name, reg_key_param, 0, 0, &reg_key_value_timeout);

			// Registry read Server Hostname
			sprintf(reg_key_param, "Hostname%ld", (unsigned long) moduleNr);
			err = DapiInternCommand(DAPI_INTERN_CMD_GET_REGISTRY_STRING, reg_key_name, reg_key_param, (char*) ip_addr, sizeof(ip_addr), (ULONG*) 0);

			sprintf(text, "Module-Configuration %s (%ld)\n\nInterface: Ethernet\nHost: %s\nPort: %ld\nTimeout %ld ms", moduleName, (unsigned long) moduleNr, ip_addr, (unsigned long) reg_key_value_port, (unsigned long) reg_key_value_timeout);

			break;
		// ------------------------------------------------

		default:
			text[0] = 0;
			break;
		// ------------------------------------------------
	}


	i=0;
	do
	{
		if(i<ModConfigTextSize) ModConfigText[i] = text[i];
		++i;
	} while(i <= strlen_n(text, sizeof(text)));
}
	// WINDOWS ---------------
	// WINDOWS ---------------
	// WINDOWS ---------------
#endif

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

void DapiInternGetRegistryKeyName(ULONG moduleID, char* ModName, unsigned long ModNameSize)
{
	char Name[200];
	unsigned long i;
	
	switch(moduleID)
	{
		case ETHERNET_MODULE:				sprintf(Name, "DELIB-CONFIG\\ETHERNET-MODULE\\Config");	break;
		case ETH_RELAIS_8:					sprintf(Name, "DELIB-CONFIG\\ETH-OR-8\\Config");		break;
		case ETH_O4_R4_ADDA:				sprintf(Name, "DELIB-CONFIG\\ETH-O4-R4\\Config");		break;
		case ETH_TTL_64:					sprintf(Name, "DELIB-CONFIG\\ETH-TTL-64\\Config");		break;
		case ETH_CUST_0:					sprintf(Name, "DELIB-CONFIG\\ETH-CUST-0\\Config");		break;

		case BS_ETH:						sprintf(Name, "DELIB-CONFIG\\BS-ETH\\Config");			break;
		case BS_SER:						sprintf(Name, "DELIB-CONFIG\\BS-SER\\Config");			break;
//		case BS_CAN:						sprintf(Name, "DELIB-CONFIG\\BS-CAN\\Config");			break;

		case RO_SER:						sprintf(Name, "DELIB-CONFIG\\RO-SER\\Config");			break;
		case RO_CAN:						sprintf(Name, "DELIB-CONFIG\\RO-CAN\\Config");			break;
		case RO_ETH:						sprintf(Name, "DELIB-CONFIG\\RO-ETH\\Config");			break;
		case RO_ETH_LC:						sprintf(Name, "DELIB-CONFIG\\RO-ETH-LC\\Config");		break;

		case NET_ETH:						sprintf(Name, "DELIB-CONFIG\\NET-ETH\\Config");			break;
		case NET_SER:						sprintf(Name, "DELIB-CONFIG\\NET-SER\\Config");			break;
		case NET_ETH_LC:					sprintf(Name, "DELIB-CONFIG\\NET-ETH-LC\\Config");		break;
		default:							sprintf(Name, "");										break;
	}
	i=0;
	do
	{
		if(i<ModNameSize) ModName[i] = Name[i];
		++i;
	} while(i <= strlen_n(Name, sizeof(Name)));
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

ULONG DapiCheckHandle(DAPI_HANDLE* DapiHandle)
{
	char debug_msg[200];

	//debug_set_function_name("DapiCheckHandle");
	//sprintf(debug_msg, "DapiHandle = %p", DapiHandle);
	//debug_error(debug_msg);

	if(DapiHandle->id != delib_id)
	{
		// DEBUG
		debug_set_function_name("DapiCheckHandle");
		sprintf(debug_msg, "********************* ILLEGAL Handle ID(0x%lx)*************", (unsigned long) DapiHandle->id);
		debug_error(debug_msg);
		// -----
		
		return DAPI_ERR_COM_DELIB_ID_INVALID;
	}
	
	if(( DapiHandle->BusType == bus_FTDI_DUAL) ||
		(DapiHandle->BusType == bus_FTDI_SINGLE_SER) ||
		(DapiHandle->BusType == bus_FTDI_SINGLE_PAR))
	{
		if(DapiHandle->ftHandle == 0)
		{
			// DEBUG			
			debug_set_function_name("DapiCheckHandle");
			sprintf(debug_msg, "********************* ILLEGAL ftHandle (=0)*************");
			debug_error(debug_msg);
			// -----
			
			return DAPI_ERR_COM_FT_HANDLE_INVALID;
		}
	}

	return DAPI_ERR_NONE;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

unsigned long restart_check_module_config(unsigned long handle32)
{
	DAPI_HANDLE *DapiHandle;
	DAPI_MODULE_PARAMS *DapiModuleParams;
	char debug_msg[200];
	ULONG ret;

	if((handle32 == 0) || (handle32 == -1)) 
	{
		return -1;
	}

	ULONGLONG handle_ull;

	if(DapiInternHandlePointerGet(handle32, &handle_ull) == RETURN_OK)
	{
		DapiHandle = (DAPI_HANDLE*) DAPI_PTR_SIZE handle_ull;
	}
	else
	{
		return DAPI_ERR_GEN_ILLEGAL_HANDLE;
	}

	DapiModuleParams = (DAPI_MODULE_PARAMS*) DAPI_PTR_SIZE DapiHandle->addr_dapi_module_params;

	ret = check_module_config(handle32);
	
	if(ret==RETURN_ERROR)
	{
		sprintf(debug_msg,"Error reading ModulParams....perhaps Module is not flashed");
		debug_info(debug_msg);

		DapiModuleParams->sw_class			= 0;
		DapiModuleParams->hw_group			= 0;
		DapiModuleParams->sw_feature1		= 0;
		DapiModuleParams->hw_interface1		= 0;

		return RETURN_OK;			
		// Es darf der nachfolgende Test nicht durchgefhrt werden, da die ModulParams
		// ja nicht gelesen werden konnten
	}

	sprintf(debug_msg,"DapiHandle->moduleID = %ld -> check now some Modules", (unsigned long) DapiHandle->moduleID);
	debug_info(debug_msg);

	switch(DapiHandle->moduleID)
	{
		// ------------------
		// ------------------
		// ------------------
		case NET_ETH:
		case NET_ETH_LC:
			sprintf(debug_msg,"Module to be opened = NET-ETH");
			debug_info(debug_msg);
			
			if((DapiModuleParams->hw_group & DAPI_HW_GROUP_NET) == 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_group | DAPI_HW_GROUP_NET not set ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			
			if((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_CFG_ETH) == 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_interface1 | DAPI_HW_INTERFACE_BIT_CFG_ETH ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			break;
		// ------------------
		case BS_ETH:
			sprintf(debug_msg,"Module to be opened = BS-ETH");
			debug_info(debug_msg);
			
			if((DapiModuleParams->hw_group & DAPI_HW_GROUP_BS) == 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_group | DAPI_HW_GROUP_BS not set ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			
			if((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_CFG_ETH) == 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_interface1 | DAPI_HW_INTERFACE_BIT_CFG_ETH ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			break;
		// ------------------
		case BS_SER:
			sprintf(debug_msg,"Module to be opened = BS-SER");
			debug_info(debug_msg);
			
			if((DapiModuleParams->hw_group & DAPI_HW_GROUP_BS) == 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_group | DAPI_HW_GROUP_BS not set ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			break;

			if((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_CFG_RS232) == 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_interface1 | DAPI_HW_INTERFACE_BIT_CFG_RS232 ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
		// ------------------
		case BS_CAN:
			sprintf(debug_msg,"Module to be opened = BS-CAN");
			debug_info(debug_msg);
			
			if((DapiModuleParams->hw_group & DAPI_HW_GROUP_BS) == 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_group | DAPI_HW_GROUP_BS not set ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}

			if((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_CFG_CAN) == 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_interface1 | DAPI_HW_INTERFACE_BIT_CFG_CAN ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			break;
		// ------------------
		// ------------------
		// ------------------
		case RO_ETH_LC:
			sprintf(debug_msg,"Module to be opened = RO-ETH/LC");
			debug_info(debug_msg);
			
			if((DapiModuleParams->hw_group & DAPI_HW_GROUP_RO) == 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_group | DAPI_HW_GROUP_RO not set ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			
			if((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_CFG_ETH) == 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_interface1 | DAPI_HW_INTERFACE_BIT_CFG_ETH ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			break;
		// ------------------
		case RO_ETH:
			sprintf(debug_msg,"Module to be opened = RO-ETH");
			debug_info(debug_msg);
		
			// Alte RO-Serien haben das Bit nicht gesetzt//check, ob das BS ist
			if((DapiModuleParams->hw_group & DAPI_HW_GROUP_BS) != 0)		
			{
				sprintf(debug_msg,"DapiModuleParams->hw_group | DAPI_HW_GROUP_BS IS set ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			break;
		// ------------------
		case RO_SER:
			sprintf(debug_msg,"Module to be opened = RO-SER");
			debug_info(debug_msg);
		
			// Alte RO-Serien haben das Bit nicht gesetzt//check, ob das BS ist
			if((DapiModuleParams->hw_group & DAPI_HW_GROUP_BS) != 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_group | DAPI_HW_GROUP_BS IS set ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			break;
		// ------------------
		case NET_SER:
			sprintf(debug_msg,"Module to be opened = RO-SER");
			debug_info(debug_msg);
		
			// Alte RO-Serien haben das Bit nicht gesetzt//check, ob das BS ist
			if((DapiModuleParams->hw_group & DAPI_HW_GROUP_BS) != 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_group | DAPI_HW_GROUP_BS IS set ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			break;
		// ------------------
		case RO_CAN:
			sprintf(debug_msg,"Module to be opened = RO-CAN");
			debug_info(debug_msg);
		
			// Alte RO-Serien haben das Bit nicht gesetzt//check, ob das BS ist
			if((DapiModuleParams->hw_group & DAPI_HW_GROUP_BS) != 0)		
			{
				sprintf(debug_msg,"DapiModuleParams->hw_group | DAPI_HW_GROUP_BS IS set ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			break;
		// ------------------
		// ------------------
		// ------------------
		case ETH_RELAIS_8:
			sprintf(debug_msg,"Module to be opened = ETH_RELAIS_8");
			debug_info(debug_msg);
			
			if((DapiModuleParams->hw_group & DAPI_HW_GROUP_ETH) == 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_group | DAPI_HW_GROUP_ETH not set ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			
			if((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_CFG_ETH) == 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_interface1 | DAPI_HW_INTERFACE_BIT_CFG_ETH ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			break;
		// ------------------
		// ------------------
		// ------------------
		case ETH_O4_R4_ADDA:
		case ETH_TTL_64:
		case ETH_CUST_0:
			sprintf(debug_msg,"Module to be opened = ETH_O4_R4_ADDA");
			debug_info(debug_msg);
			
			if((DapiModuleParams->hw_group & DAPI_HW_GROUP_ETH) == 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_group | DAPI_HW_GROUP_ETH not set ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			
			if((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_CFG_ETH) == 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_interface1 | DAPI_HW_INTERFACE_BIT_CFG_ETH ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			break;
		// ------------------
	}
	sprintf(debug_msg,"restart_check_module_config() -> RETURN_OK");
	debug_info(debug_msg);

	return RETURN_OK;
}
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiOpenModuleIntern(ULONG moduleID, ULONG moduleNr, ULONG subdevice, unsigned char* exbuffer, ULONG open_options)
{
	char debug_msg[200];
	ULONG ret;
	ULONG moduleID_copy;
	unsigned long handle32;
	FT_HANDLE ftHandle;
	DAPI_HANDLE *DapiHandle;
	DAPI_MODULE_PARAMS * DapiModuleParams;
	char moduleName[20];
	unsigned long nr;
	BOOL found;

	#ifdef __linux__
	unsigned long free_nr;
	#endif

	DapiInternGetModuleName(moduleID, moduleName, sizeof(moduleName));
	
	if((moduleNr & DAPI_OPEN_MODULE_MODULE_NR_MASK) >= MAX_NO_OF_MODULES_NR)
	{
		DapiSetError(DAPI_ERR_GEN_ILLEGAL_MODULE_NR, 0, NULL, __FILE__, __LINE__);					
		return RETURN_HANDLE_NULL;
	}

	if(moduleID > MAX_NR_OF_MODULE_IDS)
	{
		DapiSetError(DAPI_ERR_GEN_ILLEGAL_MODULE_ID, 0, NULL, __FILE__, __LINE__);					
		return RETURN_HANDLE_NULL;
	}

	if(moduleID == 0)
	{
		DapiSetError(DAPI_ERR_GEN_ILLEGAL_MODULE_ID, 0, NULL, __FILE__, __LINE__);					
		return RETURN_HANDLE_NULL;
	}

	if(subdevice==DapiModuleID_Device)
	{
		// DEBUG
		debug_set_function_name("DapiOpenModuleIntern");
		sprintf(debug_msg, "DapiOpenModuleIntern(moduleID=0x%lx, (Name=#####  %s  #####) moduleNr=0x%lx, subdevice=%s, exbuffer=0x%lx, open_options=0x%lx) Normal", (unsigned long) moduleID, moduleName, (unsigned long) moduleNr, subdevice==DapiModuleID_Device?"NormalDevice":"ProgDevice", (unsigned long) exbuffer, (unsigned long) open_options);
		debug_info(debug_msg);
		debug_info(debug_msg);
		debug_info(debug_msg);
		debug_info(debug_msg);
		debug_info(debug_msg);
		// -----
	}
	else
	{
		// DEBUG
		sprintf(debug_msg, "DapiOpenModuleIntern(moduleID=0x%lx, (Name=#####  %s  #####) moduleNr=0x%lx, subdevice=%s, exbuffer=0x%lx, open_options=0x%lx) DEBUGDevice DEBUGDevice DEBUGDevice DEBUGDevice ", (unsigned long) moduleID, moduleName, (unsigned long) moduleNr, subdevice==DapiModuleID_Device?"NormalDevice":"ProgDevice", (unsigned long) exbuffer, (unsigned long) open_options);
		debug_info(debug_msg);
		debug_info(debug_msg);
		debug_info(debug_msg);
		debug_info(debug_msg);
		debug_info(debug_msg);
		// -----
	}

	#ifndef __linux__
		// WINDOWS ---------------
		// WINDOWS ---------------
		// WINDOWS ---------------
		
		// Gibts das Modul schon ?
		nr=0;
		found=FALSE;

		do 
		{
			DapiHandle = HandleMGR_get_handle_pointer(nr);

			if((DapiHandle->moduleID == moduleID) && (DapiHandle->moduleNr == (moduleNr & MAX_NO_OF_MODULES_MASK)))
			{
				found = TRUE;

				sprintf(debug_msg, "DapiOpenModuleIntern(nr=%d - Eintrag gab es schon mit moduleID=0x%lx, moduleNr=0x%lx", nr, moduleID, moduleNr);
				debug_info(debug_msg);
			}
			else
			{
				++nr;
			}
		} while((nr < HandlePointerMAX) && (found == FALSE));
	
		if(found == FALSE)
		{
			// Gibts nicht -> ALSO den ersten freien suchen und benutzen
			nr=0;
			found=FALSE;
			do 
			{
				DapiHandle = HandleMGR_get_handle_pointer(nr);

				if((DapiHandle->moduleID == 0) && (DapiHandle->moduleNr == 0))
				{
					found = TRUE;

					sprintf(debug_msg, "DapiOpenModuleIntern(nr=%d - Eintrag gab es NICHT mit moduleID=0x%lx, moduleNr=0x%lx", nr, moduleID, moduleNr);
					debug_info(debug_msg);
				}
				else
				{
					++nr;
				}
			} while((nr < HandlePointerMAX) && (found == FALSE));
		}

		if(nr < HandlePointerMAX)
		{
			DapiHandle = HandleMGR_get_handle_pointer(nr);
			handle32 = DapiInternHandlePointerCreate(nr, (ULONGLONG) DapiHandle);
		}
		else
		{
			return RETURN_HANDLE_NULL; // 0=Handle = 0-> Error
		}
		
		// WINDOWS ---------------
		// WINDOWS ---------------
		// WINDOWS ---------------
	#else
		// LINUX ---------------
		// LINUX ---------------
		// LINUX ---------------
		
		HandleMGR_init_handle_buffer();
	
		nr = 0;
		free_nr = -1;
		found = FALSE;
		
		do 
		{	
			DapiHandle = (DAPI_HANDLE*) ((unsigned long)HandleMGR_get_handle_pointer(nr));
			if (DapiHandle != NULL)
			{
				// handle already exists
				if((DapiHandle->moduleID == moduleID) && (DapiHandle->moduleNr == (moduleNr & MAX_NO_OF_MODULES_MASK)))
				{
					// handle of this module
					found = TRUE;

					sprintf(debug_msg, "DapiOpenModuleIntern(nr=%ld - Eintrag gab es schon mit moduleID=0x%lx, moduleNr=0x%lx", (unsigned long) nr, (unsigned long) moduleID, (unsigned long) moduleNr);
					debug_info(debug_msg);
				}
			}
			else
			{	
				found = TRUE;

				free_nr = nr;
				sprintf(debug_msg, "DapiOpenModuleIntern -> nr=%ld - Eintrag ist frei", (unsigned long) free_nr);
				debug_info(debug_msg);
			}
			++nr;
		} while((nr < HandlePointerMAX) && (found == FALSE));

		if(found == TRUE)
		{
			if (free_nr != -1)
			{
				// Gibts nicht -> ALSO den ersten freien benutzen
				sprintf(debug_msg, "DapiOpenModuleIntern(Eintrag gab es NICHT mit moduleID=0x%lx, moduleNr=0x%lx)", (unsigned long) moduleID, (unsigned long) moduleNr);
				debug_info(debug_msg);
				
				handle32 = DapiInternHandlePointerCreate(free_nr);
				DapiHandle = (DAPI_HANDLE*) (DAPI_PTR_SIZE HandleMGR_get_handle_pointer(free_nr));
				
				DapiHandle->moduleID = moduleID;
				DapiHandle->moduleNr = moduleNr;				
			}
			else
			{
				// Gibts schon -> pointer vom slot holen
				handle32 = DapiInternHandlePointerCreate(nr);
				DapiHandle = (DAPI_HANDLE*) (DAPI_PTR_SIZE HandleMGR_get_handle_pointer(nr));
			}
		}
		else
		{
			return RETURN_HANDLE_NULL; // 0=Handle = 0-> Error
		}
		// LINUX ---------------
		// LINUX ---------------
		// LINUX ---------------
	#endif
	
	DapiHandle->BusType = DapiInternGetBusType(moduleID);

	if(DapiHandle->BusType == 0)
	{
		// Bus Type nicht vorhanden

		// DEBUG
		debug_set_function_name("DapiOpenModuleIntern");
		sprintf(debug_msg,"Bus Type nicht vorhanden");
		debug_error(debug_msg);
		// -----
		
		#ifdef __linux__
			DapiInternHandlePointerClear(handle32);
		#endif
		
		return RETURN_HANDLE_NULL; // 0=Handle = 0-> Error
	}

	// Kann weiter gehen .....

	// ----------------------------------------------------
	// ----------------------------------------------------
	// ----------------------------------------------------
	// FTDI_DUAL 
	
	#ifdef USE_FTDI_DUAL
		if((DapiHandle->BusType == bus_FTDI_DUAL))
		{
			moduleID_copy = moduleID;
			if((DapiHandle->ftHandle == (FT_HANDLE) -1) || (DapiHandle->id != delib_id))
			{
				// SONDERFALL BS-CAN
				if(moduleID_copy == BS_CAN)
				{
					moduleID_copy = BS_USB_8;
					ret = DapiOpenModuleIntern_FTDI(handle32, moduleID_copy, (moduleNr & MAX_NO_OF_MODULES_MASK), DapiHandle->BusType, 1, subdevice, &ftHandle, open_options);	// Retry=1, subdevice
					if(ret != DAPI_ERR_NONE)
					{
						moduleID_copy = BS_USB_16;
						ret = DapiOpenModuleIntern_FTDI(handle32, moduleID_copy, (moduleNr & MAX_NO_OF_MODULES_MASK), DapiHandle->BusType, 1, subdevice, &ftHandle, open_options);	// Retry=1, subdevice
						if(ret != DAPI_ERR_NONE)
						{
							moduleID_copy = BS_USB_32;
							ret = DapiOpenModuleIntern_FTDI(handle32, moduleID_copy, (moduleNr & MAX_NO_OF_MODULES_MASK), DapiHandle->BusType, 1, subdevice, &ftHandle, open_options);	// Retry=1, subdevice
						}
					}
				}
				else
				{
					ret = DapiOpenModuleIntern_FTDI(handle32, moduleID_copy, (moduleNr & MAX_NO_OF_MODULES_MASK), DapiHandle->BusType, 1, subdevice, &ftHandle, open_options);	// Retry=1, subdevice
				}
				

				// DEBUG
				debug_set_function_name("DapiOpenModuleIntern/FTDI_DUAL");

				sprintf(debug_msg, "ret=0x%lx", (unsigned long) ret);
				debug_info(debug_msg);

				sprintf(debug_msg, "ftHandle=0x%lx", (unsigned long) ftHandle);
				debug_info(debug_msg);
				// -----
				
				if (ret != DAPI_ERR_NONE) 
				{
					// DEBUG
					debug_set_function_name("DapiOpenModuleIntern");					
					sprintf(debug_msg,"DapiOpenModuleIntern - return=0");
					debug_info(debug_msg);
					// -----

					DapiSetError(DAPI_ERR_GEN_ILLEGAL_HANDLE, 0, NULL, __FILE__, __LINE__);

					#ifdef __linux__
						DapiInternHandlePointerClear(handle32);
					#endif

					return RETURN_HANDLE_NULL;
				}
			}
			else
			{
				ftHandle = DapiHandle->ftHandle;
			}
		
			DapiHandle->moduleID = moduleID_copy;			// Hier muss die evtl. modifizierte Modul-ID rein 
			DapiHandle->ftHandle = ftHandle;
			DapiHandle->SubDevice = subdevice;
		}
	#endif

	// ----------------------------------------------------
	// ----------------------------------------------------
	// ----------------------------------------------------
	// Seriell ber die COM
	
	#ifdef USE_SER
		if(DapiHandle->BusType == bus_SeriellCOM)
		{
			ret = DapiOpenModuleIntern_SeriellCOM(handle32, moduleID, (moduleNr & MAX_NO_OF_MODULES_MASK));
			
			if(ret != DAPI_ERR_NONE) 
			{	
				// DEBUG
				debug_set_function_name("DapiOpenModuleIntern/SeriellCOM");
				sprintf(debug_msg, "DapiOpenModuleIntern - return=0 - No module found");
				debug_error(debug_msg);
				// -----

				DapiSetError(DAPI_ERR_COM_CONN_COULD_NOT_BE_ESTABLISHED, 0, NULL, __FILE__, __LINE__);

				#ifdef __linux__
					DapiInternHandlePointerClear(handle32);
				#endif

				return RETURN_HANDLE_NULL;	// Connection to Module failed
			}
			DapiHandle->moduleID = moduleID;
		}
	#endif

	// ----------------------------------------------------
	// ----------------------------------------------------
	// ----------------------------------------------------
	// Seriell ber FTDI
	
	#ifdef USE_FTDI
		if(( DapiHandle->BusType == bus_SeriellFTDI) ||
			(DapiHandle->BusType == bus_FTDI_SINGLE_SER) ||
			(DapiHandle->BusType == bus_FTDI_SINGLE_PAR))
			{
				#ifndef __linux__
				if((DapiHandle->ftHandle == (FT_HANDLE) -1) || (DapiHandle->id != delib_id))
				{
				#endif
				ret = DapiOpenModuleIntern_FTDI(handle32, moduleID, (moduleNr & MAX_NO_OF_MODULES_MASK), DapiHandle->BusType, 1, 2, &ftHandle, open_options);	// Retry=1, subdevice=2 (ohne A oder B)

				// DEBUG
				debug_set_function_name("DapiOpenModuleIntern/SerFTDI");
				sprintf(debug_msg, "ret=0x%lx", (unsigned long) ret);
				debug_info(debug_msg);
				sprintf(debug_msg, "ftHandle=0x%lx", (unsigned long) ftHandle);
				debug_info(debug_msg);
				// -----
				
				if (ret != DAPI_ERR_NONE)
				{
					// DEBUG
					debug_set_function_name("DapiOpenModuleIntern");
					sprintf(debug_msg, "return=0 - No module found");
					debug_error(debug_msg);
					// -----
					
					DapiSetError(DAPI_ERR_COM_CONN_COULD_NOT_BE_ESTABLISHED, 0, NULL, __FILE__, __LINE__);
					
					#ifdef __linux__
						DapiInternHandlePointerClear(handle32);
					#endif

					return RETURN_HANDLE_NULL;
				}

			#ifndef __linux__
				}
				else
				{
					ftHandle = DapiHandle->ftHandle;
				}
			#endif	
			
			DapiHandle->moduleID = moduleID;
			DapiHandle->ftHandle = ftHandle;
			DapiHandle->SubDevice = 2;//subdevice;
			DapiHandle->RS485_ModuleNr = 0;
		}
	#endif

	// ----------------------------------------------------
	// ----------------------------------------------------
	// ----------------------------------------------------
	// Ethernet
	
	#ifdef USE_ETH
		if(DapiHandle->BusType == bus_ETH)
		{
			ret = DapiOpenModuleIntern_ETH(handle32, moduleID, moduleNr, exbuffer);

			if(ret != DAPI_ERR_NONE) 
			{
				// DEBUG
				debug_set_function_name("DapiOpenModuleIntern/bus_ETH");
				sprintf(debug_msg, "DapiOpenModuleIntern - return=0 - No module found");
				debug_error(debug_msg);
				// -----
				
				DapiSetError(DAPI_ERR_COM_CONN_COULD_NOT_BE_ESTABLISHED, 0, NULL, __FILE__, __LINE__);					
				
				#ifdef __linux__
					DapiInternHandlePointerClear(handle32);
				#endif

				return RETURN_HANDLE_NULL;	// Connection to Module failed
			}
			DapiHandle->moduleID = moduleID;
		}
	#endif
	
	// ----------------------------------------------------
	// ----------------------------------------------------
	// ----------------------------------------------------
	// Ethernet-Intern (Queue)
	
	#ifdef USE_ETH_INTERN
		if(DapiHandle->BusType == bus_ETH_INTERN)
		{
			ret = DapiOpenModuleIntern_ETH_INTERN(handle32, moduleID, (moduleNr & MAX_NO_OF_MODULES_MASK));
			
			if(ret!=0) 
			{
				// DEBUG
				debug_set_function_name("DapiOpenModuleIntern/bus_ETH_INTERN");
				sprintf(debug_msg, "DapiOpenModuleIntern - return=0 - No module found");
				debug_error(debug_msg);
				// -----
				
				DapiSetError(DAPI_ERR_COM_CONN_COULD_NOT_BE_ESTABLISHED, 0, NULL, __FILE__, __LINE__);					

				#ifdef __linux__
					DapiInternHandlePointerClear(handle32);
				#endif
				
				return RETURN_HANDLE_NULL;	// Connection to Module failed
			}
			DapiHandle->moduleID = moduleID;
		}
	#endif

	// ----------------------------------------------------
	// ----------------------------------------------------
	// ----------------------------------------------------
	
	DapiClearLastError();

	DapiHandle->addr_dapi_module_params = (ULONGLONG) DAPI_PTR_SIZE malloc(sizeof(DAPI_MODULE_PARAMS));
	
	if (DapiHandle->addr_dapi_module_params == (ULONGLONG) DAPI_PTR_SIZE NULL)
	{
		sprintf(debug_msg, "malloc() for DapiHandle->addr_dapi_module_params has failed!!");
		DapiSetError(DAPI_ERR_COM_CONN_COULD_NOT_BE_ESTABLISHED, 0, debug_msg, __FILE__, __LINE__);
		
		#ifdef __linux__
			DapiInternHandlePointerClear(handle32);
		#endif
		
		return RETURN_HANDLE_NULL;
	}

	DapiModuleParams = (DAPI_MODULE_PARAMS*) DAPI_PTR_SIZE DapiHandle->addr_dapi_module_params;

	sprintf(debug_msg,"MALLOC ok *  DapiModuleParams=P %p ** sizeof(DAPI_MODULE_PARAMS)=0x%lx", DapiModuleParams, (unsigned long) sizeof(DAPI_MODULE_PARAMS));
	debug_info(debug_msg);

	memset((void*) DapiModuleParams, 0, sizeof(DAPI_MODULE_PARAMS));

	sprintf(debug_msg,"MALLOC ok *  nach memset");
	debug_info(debug_msg);
	// ----------------------------------------------------
	// Setting Default/Start Values for DapiHandle
	DapiHandle->id = delib_id;
	//DapiHandle->moduleID = moduleID;		// Die moduleID auf KEINEN FALL - ist evtl. eine andere
	DapiHandle->moduleNr = (moduleNr & MAX_NO_OF_MODULES_MASK);

	DapiHandle->ProgramName[0] = 0;				// Clear Prog.Name
	DapiHandle->ftdi_use_protocol_new = FALSE;

	DapiHandle->is_Adr_32_mode = FALSE;

	DapiHandle->packet_statistic_cnt_DELIB_ERR_NONE = 0;
	DapiHandle->packet_statistic_cnt_DELIB_ERR_CLASS_GEN = 0;
	DapiHandle->packet_statistic_cnt_DELIB_ERR_CLASS_COM = 0;
	DapiHandle->packet_statistic_cnt_DELIB_ERR_CLASS_DEV_PKT = 0;
	DapiHandle->packet_statistic_cnt_DELIB_ERR_CLASS_DEV_IO = 0;
	DapiHandle->packet_statistic_cnt_DELIB_ERR_CLASS_DEV_OTHER = 0;

	DapiHandle->packet_statistic_transmit_normal_time_us_min = 0;
	DapiHandle->packet_statistic_transmit_normal_time_us_max = 0;
	DapiHandle->packet_statistic_transmit_normal_count_retry = 0;
	DapiHandle->packet_statistic_transmit_normal_count_recon = 0;
	
	DapiHandle->packet_statistic_transmit_multiple_time_us_min = 0;
	DapiHandle->packet_statistic_transmit_multiple_time_us_max = 0;
	DapiHandle->packet_statistic_transmit_multiple_count_retry = 0;
	DapiHandle->packet_statistic_transmit_multiple_count_recon = 0;


	// DEBUG
	debug_set_function_name("DapiOpenModuleIntern");
	sprintf(debug_msg,"DapiHandle->id            = 0x%lx", (unsigned long) DapiHandle->id);										debug_info(debug_msg);
	sprintf(debug_msg,"DapiHandle->ftHandle      = 0x%llx", (ULONGLONG) DAPI_PTR_SIZE DapiHandle->ftHandle);					debug_info(debug_msg);
	sprintf(debug_msg,"DapiHandle->tcp_params    = 0x%llx", (ULONGLONG) DAPI_PTR_SIZE DapiHandle->tcp_params);					debug_info(debug_msg);
	sprintf(debug_msg,"DapiHandle->TCPHandle_tx  = 0x%lx", (unsigned long) DapiHandle->TCPHandle_tx);							debug_info(debug_msg);
	sprintf(debug_msg,"DapiHandle->moduleID      = 0x%lx #####  %s  #####", (unsigned long) DapiHandle->moduleID, moduleName);	debug_info(debug_msg);
	sprintf(debug_msg,"DapiHandle->moduleNr      = 0x%lx", (unsigned long) DapiHandle->moduleNr);								debug_info(debug_msg);
	sprintf(debug_msg,"DapiHandle->SubDevice     = 0x%lx - %s", (unsigned long) DapiHandle->SubDevice, DapiHandle->SubDevice==DapiModuleID_Device?"NormalDevice":"ProgDevice"); debug_info(debug_msg);
	sprintf(debug_msg,"DapiHandle->jobID         = 0x%lx", (unsigned long) DapiHandle->jobID);									debug_info(debug_msg);
	sprintf(debug_msg,"DapiHandle->BusType       = 0x%lx", (unsigned long) DapiHandle->BusType);								debug_info(debug_msg);
	sprintf(debug_msg,"DapiHandle->ComPort       = 0x%lx", (unsigned long) DapiHandle->ComPort);								debug_info(debug_msg);
	sprintf(debug_msg,"DapiHandle->RS485_ModuleNr= 0x%lx", (unsigned long) DapiHandle->RS485_ModuleNr);							debug_info(debug_msg);
	sprintf(debug_msg,"DapiHandle->retry         = 0x%lx", (unsigned long) DapiHandle->retry);									debug_info(debug_msg);
	sprintf(debug_msg,"DapiHandle->timeout       = %ld dez", (unsigned long) DapiHandle->timeout);								debug_info(debug_msg);
	// -----
	
	// Das muss vor dem restart_module_config geschehen
	if(moduleID == USB_CANOPEN_STICK)
	{
		#ifndef linux
		DapiCANCommandXXX(handle32, DAPI_CAN_CMD_SET_BITRATE, DAPI_CAN_BITRATE_1000000, 0, 0);
		DapiCANCommandXXX(handle32, DAPI_CAN_CMD_SET_MASK0, DAPI_CAN_MASK_ALL, 0, 0);
		DapiCANCommandXXX(handle32, DAPI_CAN_CMD_SET_RX_ADDRESS, DAPI_PAR_CAN_MESSAGE_BOX_0, 0x1, 0);
		#endif
	}

	if((DapiHandle->SubDevice == DapiModuleID_DeviceProg) || ((moduleNr & DAPI_OPEN_MODULE_OPTION_DISABLE_CHK_MODULE_CFG) != 0))
	{
		// ----------------------------
		// DEBUG
		debug_set_function_name("DapiOpenModuleIntern");
		
		sprintf(debug_msg,"check_module_config wird NICHT DURCHGEFHRT ***** DapiModuleID_DeviceProg-Mode");
		debug_info(debug_msg);

		DapiModuleParams->sw_class			= 0;
		DapiModuleParams->hw_group			= 0;
		DapiModuleParams->sw_feature1		= 0;
		DapiModuleParams->hw_interface1		= 0;
		DapiModuleParams->moduleID			= DapiHandle->moduleID;

		// -----
		// ----------------------------
	}
	else
	{
		if (restart_check_module_config(handle32) != RETURN_OK)
		{
			free(DapiModuleParams);

			sprintf(debug_msg, "restart_check_module_config -> ERROR\n");		debug_info(debug_msg);
			sprintf(debug_msg, "free(DapiModuleParams)\n");						debug_info(debug_msg);

			#ifdef __linux__
				DapiInternHandlePointerClear(handle32);
			#endif
			
			return RETURN_HANDLE_NULL;// Return Handle=0 wegen Error
		}
	}

	if((DapiModuleParams->hw_group & DAPI_HW_GROUP_NET) != 0)
	{
		// NET Serie hat 32 Bit Adressierungs-Modus
		DapiHandle->is_Adr_32_mode = TRUE;
	}

	HandleMGR_show_handle_buffer();

	// DEBUG
	debug_set_function_name("DapiOpenModuleIntern");

	sprintf(debug_msg,"-----------------------------------------Funktion-Ende / return=0x%lx", handle32);	
	debug_info(debug_msg);
	// -----
	
	return handle32;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiOpenModule(ULONG moduleID, ULONG moduleNr)
{
	char dapi_caller_text[200];
	unsigned long ret;

	// --------------------------------
	DapiInternPreventSecondCallStart();
	// --------------------------------
	
	sprintf(dapi_caller_text, "DapiOpenModule(0x%lx, 0x%lx)", (unsigned long) moduleID, (unsigned long) moduleNr);

	DapiSetErrorCallerParamsSet(0, dapi_caller_text, sizeof(dapi_caller_text));

	// den internen Aufruf noch durchfhren

	ret = DapiOpenModuleXXX(moduleID, moduleNr);

	// --------------------------------
	DapiInternPreventSecondCallEnd();
	// --------------------------------

	return ret;
}

// ----------------------------------------------------------------------------

DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiOpenModuleXXX(ULONG moduleID, ULONG moduleNr)
{
	ULONG ret;
	char debug_msg[200];
	
	// DEBUG
	debug_set_function_name("DapiOpenModule");
	sprintf(debug_msg, "DapiOpenModule(0x%lx, 0x%lx)", (unsigned long) moduleID, (unsigned long) moduleNr);
	debug_info(debug_msg);
	// -----

	DapiClearLastError();

	ret = DapiOpenModuleIntern(moduleID, moduleNr, DapiModuleID_Device, (unsigned char*) 0, 0);

	// DEBUG
	debug_set_function_name("DapiOpenModule");
	sprintf(debug_msg, "return = 0x%lx", (unsigned long) ret);
	debug_info(debug_msg);
	// -----
	
/*	if(ret!=0) 
	{
		DapiClearLastError();
	}
*/
	return ret;	
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiOpenModuleEx(ULONG moduleID, ULONG moduleNr, unsigned char* exbuffer, ULONG open_options)
{
	char dapi_caller_text[200];
	unsigned long ret;

	// --------------------------------
	DapiInternPreventSecondCallStart();
	// --------------------------------
	
	sprintf(dapi_caller_text, "DapiOpenModuleEx(0x%lx, 0x%lx)", (unsigned long) moduleID, (unsigned long) moduleNr);
	DapiSetErrorCallerParamsSet(0, dapi_caller_text, sizeof(dapi_caller_text));

	ret = DapiOpenModuleExXXX(moduleID, moduleNr, exbuffer, open_options);

	// --------------------------------
	DapiInternPreventSecondCallEnd();
	// --------------------------------

	return ret;
}

// ----------------------------------------------------------------------------

DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiOpenModuleExXXX(ULONG moduleID, ULONG moduleNr, unsigned char* exbuffer, ULONG open_options)
{
	ULONG ret;
	char debug_msg[200];

	// DEBUG
	debug_set_function_name("DapiOpenModuleEx");
	sprintf(debug_msg, "DapiOpenModuleEx(0x%lx, 0x%lx, 0x%lx, options=0x%lx)", (unsigned long) moduleID, (unsigned long) moduleNr, (unsigned long) exbuffer, (unsigned long) open_options);
	debug_info(debug_msg);
	// -----
	
	ret = DapiOpenModuleIntern(moduleID, moduleNr, DapiModuleID_Device, exbuffer, open_options);

	// DEBUG
	debug_set_function_name("DapiOpenModuleEx");
	sprintf(debug_msg, "return = 0x%lx", (unsigned long) ret);
	debug_info(debug_msg);
	// -----
	
	if(ret!=0) 
	{
		DapiClearLastError();
	}

	return ret;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiCloseModule(ULONG handle)
{
	char dapi_caller_text[200];
	unsigned long ret;

	// --------------------------------
	DapiInternPreventSecondCallStart();
	// --------------------------------
	
	sprintf(dapi_caller_text, "DapiCloseModule(0x%lx)", (unsigned long) handle);
	DapiSetErrorCallerParamsSet(0, dapi_caller_text, sizeof(dapi_caller_text));

	ret = DapiCloseModuleXXX(handle);

	// --------------------------------
	DapiInternPreventSecondCallEnd();
	// --------------------------------

	return ret;
}

// ----------------------------------------------------------------------------

DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiCloseModuleXXX(ULONG handle32)
{
	DAPI_HANDLE *DapiHandle;
	DAPI_MODULE_PARAMS *DapiModuleParams;
	char debug_msg[200];

	if((handle32 == 0) || (handle32 == -1)) 
	{
		return DAPI_ERR_COM_HANDLE_INVALID;
	}

	ULONGLONG handle_ull;

	if(DapiInternHandlePointerGet(handle32, &handle_ull) == RETURN_OK)
	{
		DapiHandle = (DAPI_HANDLE*) DAPI_PTR_SIZE handle_ull;
	}
	else
	{
		return DAPI_ERR_GEN_ILLEGAL_HANDLE;
	}

	DapiModuleParams = (DAPI_MODULE_PARAMS*) DAPI_PTR_SIZE DapiHandle->addr_dapi_module_params;

	// DEBUG
	debug_set_function_name("DapiCloseModule");
	sprintf(debug_msg, "DapiCloseModule(0x%lx) ***************************************************", (unsigned long) handle32);
	debug_info(debug_msg);
	debug_info(debug_msg);
	debug_info(debug_msg);
	// -----

	// ----------------------------------------------------
	// ----------------------------------------------------
	// ----------------------------------------------------
	// FTDI
	
	#ifdef USE_FTDI
		if(( DapiHandle->BusType == bus_FTDI_DUAL) ||
			(DapiHandle->BusType == bus_FTDI_SINGLE_SER) ||
			(DapiHandle->BusType == bus_FTDI_SINGLE_PAR))
		{
			// DEBUG
			debug_set_function_name("DapiCloseModule");
			sprintf(debug_msg, "FT_Close(0x%lx)  -Bus-Typ = bus_FTDI", (unsigned long) DapiHandle->ftHandle);
			debug_info(debug_msg);
			// -----
			
			FT_Close(DapiHandle->ftHandle);
			DapiHandle->ftHandle = (FT_HANDLE) -1;		// Clear Handle
		}
	#endif

	// ----------------------------------------------------
	// ----------------------------------------------------
	// ----------------------------------------------------
	// FTDI
	
	#ifdef USE_FTDI_SER
		if(DapiHandle->BusType == bus_SeriellCOM)
		{
			// DEBUG
			debug_set_function_name("DapiCloseModule");
			sprintf(debug_msg, "DapiSeriellCOMCloseComPort(0x%lx) - Bus-Typ = bus_SeriellCOM", (unsigned long) (DapiHandle->ComPort));
			debug_info(debug_msg);
			// -----
			
			DapiSeriellCOMCloseComPort(DapiHandle->ComPort);
		}
	#endif

	// ----------------------------------------------------
	// ----------------------------------------------------
	// ----------------------------------------------------
	// Seriell ber FTDI
	
	#ifdef USE_FTDI
		if(DapiHandle->BusType == bus_SeriellFTDI)
		{
			// DEBUG
			debug_set_function_name("DapiCloseModule");
			sprintf(debug_msg, "FT_Close(0x%lx)  -Bus-Typ = bus_SeriellFTDI", (unsigned long) DapiHandle->ftHandle);
			debug_info(debug_msg);
			// -----
		
			FT_Close(DapiHandle->ftHandle);
			DapiHandle->ftHandle = (FT_HANDLE) -1;		// Clear Handle
		}
	#endif
	
	// ----------------------------------------------------
	// ----------------------------------------------------
	// ----------------------------------------------------
	// Ethernet

	#ifdef USE_ETH
		if(DapiHandle->BusType == bus_ETH)
		{
			// DEBUG
			debug_set_function_name("DapiCloseModule");
			sprintf(debug_msg, "tcp_tx_close(0x%lx)  -Bus-Typ = bus_ETH", (unsigned long) DapiHandle->tcp_params);
			debug_info(debug_msg);
			// -----
		
			tcp_tx_close(DapiHandle->tcp_params);

			DapiHandle->tcp_params = NULL;

		}
	#endif
	
	// ----------------------------------------------------
	// ----------------------------------------------------
	// ----------------------------------------------------
	// Ethernet-Intern (Queue)
	
	#ifdef USE_ETH_INTERN
		if(DapiHandle->BusType == bus_ETH_INTERN)
		{
			// DEBUG
			debug_set_function_name("DapiCloseModule");
			sprintf(debug_msg, "DapiCloseModuleIntern_ETH_INTERN(0x%lx)  -Bus-Typ = bus_ETH_INTERN", (unsigned long) handle);
			debug_info(debug_msg);
			// -----
		
			DapiCloseModuleIntern_ETH_INTERN(handle);
		}
	#endif

	// ----------------------------------------------------
	// ----------------------------------------------------
	// ----------------------------------------------------
		
	debug_set_function_name("DapiCloseModule");
	sprintf(debug_msg, "DapiHandle->packet_statistic_cnt_DELIB_ERR_NONE = %ld\n", (unsigned long) DapiHandle->packet_statistic_cnt_DELIB_ERR_NONE);								debug_info(debug_msg);
	sprintf(debug_msg, "DapiHandle->packet_statistic_cnt_DELIB_ERR_CLASS_GEN = %ld\n", (unsigned long) DapiHandle->packet_statistic_cnt_DELIB_ERR_CLASS_GEN);					debug_info(debug_msg);
	sprintf(debug_msg, "DapiHandle->packet_statistic_cnt_DELIB_ERR_CLASS_COM = %ld\n", (unsigned long) DapiHandle->packet_statistic_cnt_DELIB_ERR_CLASS_COM);					debug_info(debug_msg);
	sprintf(debug_msg, "DapiHandle->packet_statistic_cnt_DELIB_ERR_CLASS_DEV_PKT = %ld\n", (unsigned long) DapiHandle->packet_statistic_cnt_DELIB_ERR_CLASS_DEV_PKT);			debug_info(debug_msg);
	sprintf(debug_msg, "DapiHandle->packet_statistic_cnt_DELIB_ERR_CLASS_DEV_IO = %ld\n", (unsigned long) DapiHandle->packet_statistic_cnt_DELIB_ERR_CLASS_DEV_IO);				debug_info(debug_msg);
	sprintf(debug_msg, "DapiHandle->packet_statistic_cnt_DELIB_ERR_CLASS_DEV_OTHER = %ld\n", (unsigned long) DapiHandle->packet_statistic_cnt_DELIB_ERR_CLASS_DEV_OTHER);		debug_info(debug_msg);

	sprintf(debug_msg, "DapiHandle->packet_statistic_transmit_normal_time_us_min = %ld\n", (unsigned long) DapiHandle->packet_statistic_transmit_normal_time_us_min);			debug_info(debug_msg);
	sprintf(debug_msg, "DapiHandle->packet_statistic_transmit_normal_time_us_max = %ld\n", (unsigned long) DapiHandle->packet_statistic_transmit_normal_time_us_max);			debug_info(debug_msg);
	sprintf(debug_msg, "DapiHandle->packet_statistic_transmit_normal_count_retry = %ld\n", (unsigned long) DapiHandle->packet_statistic_transmit_normal_count_retry);			debug_info(debug_msg);
	sprintf(debug_msg, "DapiHandle->packet_statistic_transmit_normal_count_recon = %ld\n", (unsigned long) DapiHandle->packet_statistic_transmit_normal_count_recon);			debug_info(debug_msg);
	
	sprintf(debug_msg, "DapiHandle->packet_statistic_transmit_multiple_time_us_min = %ld\n", (unsigned long) DapiHandle->packet_statistic_transmit_multiple_time_us_min);		debug_info(debug_msg);
	sprintf(debug_msg, "DapiHandle->packet_statistic_transmit_multiple_time_us_max = %ld\n", (unsigned long) DapiHandle->packet_statistic_transmit_multiple_time_us_max);		debug_info(debug_msg);
	sprintf(debug_msg, "DapiHandle->packet_statistic_transmit_multiple_count_retry = %ld\n", (unsigned long) DapiHandle->packet_statistic_transmit_multiple_count_retry);		debug_info(debug_msg);
	sprintf(debug_msg, "DapiHandle->packet_statistic_transmit_multiple_count_recon = %ld\n", (unsigned long) DapiHandle->packet_statistic_transmit_multiple_count_recon);		debug_info(debug_msg);
	
	DapiClearLastError();
	
	free(DapiModuleParams);

	sprintf(debug_msg, "free(DapiModuleParams)\n");		debug_info(debug_msg);

	// Eintrag lschen
	DapiHandle->moduleID = 0;
	DapiHandle->moduleNr = 0;
	
	DapiInternHandlePointerClear(handle32);

	HandleMGR_show_handle_buffer();
	
	// CC	26.06.2017	Linux: free is called in DapiInternHandlePointerClear

	return DAPI_ERR_NONE;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiGetDELIBVersion(ULONG mode, ULONG par)
{
	unsigned long ret;
	// --------------------------------
	DapiInternPreventSecondCallStart();
	// --------------------------------

	if((mode==0) && (par==0)) 
	{
		ret = (DELIB_VERSION);
	}
	else if((mode==0) && (par==1)) 
	{
		ret = (DELIB_VERSION_SUB);
	}
	else if(mode==1) 
	{
		#ifdef _WIN64
			// WINDOWS x64 -------------
			// WINDOWS x64 -------------
			// WINDOWS x64 -------------
			ret = 64;	// 64 Bit DELIB
			// WINDOWS x64 -------------
			// WINDOWS x64 -------------
			// WINDOWS x64 -------------
		#else
			// WINDOWS x86 -------------
			// WINDOWS x86 -------------
			// WINDOWS x86 -------------
			ret = 32;	// 32 Bit DELIB
			// WINDOWS x86 -------------
			// WINDOWS x86 -------------
			// WINDOWS x86 -------------
		#endif

	}
	else
	{
		ret = 0;
	}

	// --------------------------------
	DapiInternPreventSecondCallEnd();
	// --------------------------------

	return ret;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

void DapiInternCloseAllSubmodules(ULONG moduleID)
{
	#ifndef linux
		ULONG nr;
		char debug_msg[200];
		DAPI_HANDLE *DapiHandle;

		for(nr=0;nr!=HandlePointerMAX;++nr)
		{
			DapiHandle = HandleMGR_get_handle_pointer(nr);

			if(DapiHandle->moduleID == moduleID)
			{
				// Dieser Handle ist fr die gesuche moduleID

				// DEBUG
				debug_set_function_name("DapiInternCloseAllSubmodules");
				sprintf(debug_msg, "DapiInternCloseAllSubmodules nr=%d", nr);
				debug_info(debug_msg);
				// -----

				
				// DEBUG
				debug_set_function_name("DapiInternCloseAllSubmodules");
				sprintf(debug_msg, "DapiInternCloseAllSubmodules handle=0x%x", (unsigned long) DapiHandle);
				debug_info(debug_msg);
				// -----
				
				DapiCloseModuleXXX((unsigned long) DapiHandle);
			}
		}
	#endif
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

unsigned long GetModuleIDFromTCPBLBoardID(unsigned long boardID)
{
	unsigned long ret = RETURN_ERROR;;	
	
	switch (boardID)
	{
		case 0x0f: ret = RO_ETH_LC;       break;
		case 0x0e: ret = BS_ETH;          break;
		case 0x0d: ret = ETH_RELAIS_8;    break;
		case 0x0c: ret = ETH_O4_R4_ADDA;  break;
		case 0x0b: ret = ETH_TTL_64;      break;
		case 0x0a: ret = NET_ETH_LC;      break;
		case 0x00: ret = ETH_CUST_0;       break;
		default:   ret = RETURN_ERROR;    break;
	}

	return ret;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

unsigned long GetModuleIDFromTCPModule(unsigned long handle)
{
	#ifndef __linux__
	unsigned long ret;
	unsigned char dev_cfg[256];
	unsigned long dev_cfg_length = 0;

	// device config ber tcp holen
	ret = DapiSpecialCommandExtXXX(handle, DAPI_SPECIAL_CMDEXT_TCP_MODULE_GET_CURRENT_CONFIG, (ULONG) NULL, (ULONG) NULL, (ULONG) NULL, NULL, NULL, NULL, NULL, (ULONG) NULL, NULL, (ULONG) NULL, dev_cfg, sizeof(dev_cfg), &dev_cfg_length);
	if ((DapiGetLastError() != DAPI_ERR_NONE) || (ret != DAPI_ERR_NONE))
	{
		// keine device config...
		return RETURN_ERROR;
	}

	// device config ist da!
	ret = RETURN_ERROR;
	if (dev_cfg[106] == 1)
	{
		// device config hat eintrag fr ModuleID
		ret = GetModuleIDFromTCPBLBoardID(dev_cfg[108]);
	}

	return ret;
	#else
		return 0;
	#endif
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
