//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
//
//
//	delib_extended_functions.h
//	project: DELIB
//
//
//	(c) DEDITEC GmbH, 2009-2020
//	web: http://www.deditec.de/
//	mail: vertrieb@deditec.de
//
//
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************

// --------------------------------------------------------
DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE  DapiProgDevice(ULONG moduleID, ULONG moduleNr,  ULONG todo, ULONG mode, char *filename, ULONG ffunction);
DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE  DapiProgDeviceNextState(ULONG prog_handle, char *msg, ULONG msg_size, ULONG *progress_percent);

DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE  DapiOpenDebugChannel(ULONG moduleID, ULONG moduleNr);
DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE  DapiReadDebugChannel(ULONG handle, char* buff, ULONG bufflen);
DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE  DapiWriteDebugChannel(ULONG handle, char* buff, ULONG bufflen);
DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE  DapiCloseDebugChannel(ULONG handle);

DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE  DapiInternCommand(ULONG cmd, char* par1, char* par2, char* par3, ULONG par4, ULONG *par5);
DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE  DapiOpenModuleIntern(ULONG moduleID, ULONG moduleNr, ULONG subdevice, unsigned char* exbuffer, ULONG open_options);



#define ProgDeviceErr_NONE									0
#define ProgDeviceErr_END									100
#define ProgDeviceErr_DeviceOpenError						1
#define ProgDeviceErr_MemoryAllocError						5
#define ProgDeviceErr_FileNotFound							2
#define ProgDeviceErr_FlashDataError						3
#define ProgDeviceErr_SyncError								4

// --------------------------------------------------------
// DAPI_INTERN Commands (ohne handle)

#define DAPI_INTERN_CMD_GET_REGISTRY_STRING					1
#define DAPI_INTERN_CMD_SET_REGISTRY_STRING					2
#define DAPI_INTERN_CMD_GET_REGISTRY_DWORD					3
#define DAPI_INTERN_CMD_SET_REGISTRY_DWORD					4

#define DAPI_INTERN_CMD_BC_GET_MAC_LIST						5
#define DAPI_INTERN_CMD_BC_GET_PARAMETER					6
#define DAPI_INTERN_CMD_BC_SET_PARAMETER					7
#define DAPI_INTERN_CMD_BC_ETH0_CONFIG						8
#define DAPI_INTERN_CMD_BC_GET_MAC_LIST_WITH_DEV_CFG		14

#define DAPI_INTERN_GET_MODULE_NAME							9
#define DAPI_INTERN_GET_MODULE_BUS_TYPE						10
#define DAPI_INTERN_GET_MODULE_INTERFACE_TYPE				11
#define DAPI_INTERN_GET_REGISTRY_KEY_NAME					12
#define DAPI_INTERN_GET_MODULE_CONFIG_TEXT					13
#define DAPI_INTERN_GET_TCP_MODULE_ID_FROM_BL_BOARD_ID		15


// --------------------------------------------------------
// DAPI_SPECIAL Commands (die NICHT in der DELIB.h stehen sollen)

#define DAPI_SPECIAL_CMD_MODULE_CONFIG						0xf0000001
#define DAPI_SPECIAL_MODULECFG_MODULE_ID_SET				1

#define DAPI_SPECIAL_CMD_ROCPU_EEPROM_ERASE					0x10
#define DAPI_SPECIAL_CMD_ROCPU_EEPROM_WRITE_1K_2K			0x11
#define DAPI_SPECIAL_CMD_ROCPU_EEPROM_READ_1K_2K			0x12

#define DAPI_SPECIAL_CMD_ROCPU_SUBMODULE_GET_INFOS			0xf0001003
#define DAPI_SPECIAL_CMD_ROCPU_SUBMODULE_GO_BOOTLOADER		0xf0001004
#define DAPI_SPECIAL_CMD_ROCPU_SUBMODULE_EEPROM_WRITE		0xf0001005

#define DAPI_SPECIAL_CMD_NETCPU_SUBMODULE_GET_INFOS			0xf0001100
#define DAPI_SPECIAL_CMD_RS485_MODULE_NR_SET				0xf0000002
#define DAPI_SPECIAL_CMD_TCP_TX_RX_TESTDATA					0xf0000003
#define DAPI_SPECIAL_CMD_DELIB_SET_PROG_NAME				0xf0000004
#define DAPI_SPECIAL_CMD_RENESAS_RESET						0xf0000005
#define DAPI_SPECIAL_CMD_FT_CBUS_SET						0xf0000006
#define DAPI_SPECIAL_CMD_FT_CBUS_GET						0xf0000007
#define DAPI_SPECIAL_CMD_RENESAS_RESET_MODE0				0xf0000008
#define DAPI_SPECIAL_CMD_GET_PKT_STAT						0xf0000009

#define DAPI_SPECIAL_CMD_SET_OUTPUT_WITH_ENCRYPTION			0xffef0123

// EXT
#define DAPI_SPECIAL_CMDEXT_TCP_MODULE_GET_CONFIG_DATA		0xf0000009
#define DAPI_SPECIAL_CMDEXT_TCP_MODULE_SET_CONFIG_DATA		0xf000000A
#define DAPI_SPECIAL_CMDEXT_TCP_MODULE_IDENTIFY				0xf000000B
#define DAPI_SPECIAL_CMDEXT_TCP_MODULE_ACTIVATE_ADMIN_TEMP	0xf000000C
#define DAPI_SPECIAL_CMDEXT_TCP_MODULE_RELOAD_ETH_CONFIG 	0xf000000D
#define DAPI_SPECIAL_CMDEXT_TCP_MODULE_GET_CURRENT_CONFIG	0xf000000E
#define DAPI_SPECIAL_CMDEXT_TCP_MODULE_SET_MAC_ADDR			0xf000000F
#define DAPI_SPECIAL_CMDEXT_TCP_MODULE_GET_MAC_ADDR			0xf0000010
#define DAPI_SPECIAL_CMDEXT_READ_EE_DIRECTORY				0xf0000011
#define DAPI_SPECIAL_CMDEXT_WRITE_EE_DIRECTORY				0xf0000012
#define DAPI_SPECIAL_CMDEXT_DELIB_SET_PROG_NAME				0xf0000013
#define DAPI_SPECIAL_CMDEXT_ROCPU_SUBMODULE_GET_INFOS		0xf0000014
#define DAPI_SPECIAL_CMDEXT_NETCPU_SUBMODULE_GET_INFOS		0xf0000015
#define DAPI_SPECIAL_CMDEXT_ROCPU_EEPROM_READ_1K_2K			0xf0000016
#define DAPI_SPECIAL_CMDEXT_ROCPU_EEPROM_WRITE_1K_2K		0xf0000017
#define DAPI_SPECIAL_CMDEXT_SET_RTC							0xf0000018
#define DAPI_SPECIAL_CMDEXT_GET_RTC							0xf0000019
#define DAPI_SPECIAL_CMDEXT_SUBMODULE_BUFFER_CMD			0xf000001A
#define DAPI_SPECIAL_CMDEXT_DELIB_ADDR_MODE_GET				0xf000001B
#define DAPI_SPECIAL_CMDEXT_DELIB_ADDR_MODE_SET				0xf000001C
#define DAPI_SPECIAL_CMDEXT_RESTORE_EEPROM_DEFAULT			0xf000001D


#define DAPI_SPECIAL_CMDEXT_CALL_SPECIAL_CMD_TYP_BUFF		0xf00000FF
// --------------------------------------------------------

// par1 fr DAPI_SPECIAL_CMD_GET_PKT_STAT
#define DAPI_SPECIAL_CMD_GET_PKT_STAT_PAR_CNT_DELIB_ERROR_NONE				0
#define DAPI_SPECIAL_CMD_GET_PKT_STAT_PAR_CNT_DELIB_ERROR_CLASS_GEN			1
#define DAPI_SPECIAL_CMD_GET_PKT_STAT_PAR_CNT_DELIB_ERROR_CLASS_COM			2
#define DAPI_SPECIAL_CMD_GET_PKT_STAT_PAR_CNT_DELIB_ERROR_CLASS_DEV_PKT		3
#define DAPI_SPECIAL_CMD_GET_PKT_STAT_PAR_CNT_DELIB_ERROR_CLASS_DEV_IO		4
#define DAPI_SPECIAL_CMD_GET_PKT_STAT_PAR_CNT_DELIB_ERROR_CLASS_DEV_OTHER 	5
#define DAPI_SPECIAL_CMD_GET_PKT_STAT_PAR_TIME_MIN_TRANS_NORMAL 			100
#define DAPI_SPECIAL_CMD_GET_PKT_STAT_PAR_TIME_MAX_TRANS_NORMAL 			101
#define DAPI_SPECIAL_CMD_GET_PKT_STAT_PAR_CNT_RETRY_TRANS_NORMAL 			102
#define DAPI_SPECIAL_CMD_GET_PKT_STAT_PAR_CNT_RECON_TRANS_NORMAL 			103
#define DAPI_SPECIAL_CMD_GET_PKT_STAT_PAR_TIME_MIN_TRANS_MULTIPLE 			110
#define DAPI_SPECIAL_CMD_GET_PKT_STAT_PAR_TIME_MAX_TRANS_MULTIPLE  			111
#define DAPI_SPECIAL_CMD_GET_PKT_STAT_PAR_CNT_RETRY_TRANS_MULTIPLE  		112
#define DAPI_SPECIAL_CMD_GET_PKT_STAT_PAR_CNT_RECON_TRANS_MULTIPLE  		113

